<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.identity.relyingparty.ui.client.AuthenticationServiceClient" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.client.RelyingPartyServiceClient" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.dto.OpenIDDTO" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.dto.OpenIDSignInDTO" %>
<%@ page import="org.wso2.carbon.identity.relyingparty.ui.openid.OpenIDConsumer" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.util.ArrayList" %>

<%
    String cssLocation = request.getParameter("css");
    if ("null".equals(cssLocation)) {
        cssLocation = null;
    }

    if (cssLocation != null) {
        cssLocation = URLDecoder.decode(cssLocation, "UTF-8");
    }

    String pageTitle = request.getParameter("title");
    if (pageTitle != null) {
        pageTitle = URLDecoder.decode(pageTitle, "UTF-8");
    }

    String forwardPage = request.getParameter("forwardPage");
    if (forwardPage != null) {
        forwardPage = URLDecoder.decode(forwardPage, "UTF-8");
        session.setAttribute("forwardPage", forwardPage);
    }

    String serverURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext()
                    .getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = null;
    OpenIDDTO openID = null;
    String forwardTo = null;
    String BUNDLE = "org.wso2.carbon.identity.relyingparty.ui.i18n.Resources";
    ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());

    try {
        openID = OpenIDConsumer.getInstance().validateOpenIDAuthentication(request);

        RelyingPartyServiceClient client =
                new RelyingPartyServiceClient(cookie, serverURL, configContext);
        AuthenticationServiceClient authClient = null;
        OpenIDSignInDTO signin = null;
        signin = client.signInWithOpenID(openID);

        if (signin.getAuthenticated()) {
            cookie = client.getCookie();
            authClient = new AuthenticationServiceClient(cookie, serverURL, configContext);
            ArrayList<String> list = authClient.getSystemPermissionOfUser(signin.getUserID());

            session.setAttribute(ServerConstants.USER_PERMISSIONS, list);
            session.setAttribute(ServerConstants.ADMIN_SERVICE_COOKIE, cookie);
            session.setAttribute(CarbonConstants.SERVER_URL, serverURL);
            session.setAttribute("authenticated", signin.getAuthenticated());
            session.setAttribute("logged-user", signin.getUserID());
            CarbonUIUtil.removeMenuDefinition("user_registration_menu", request);
            CarbonUIUtil.removeMenuDefinition("infocard_sign_in", request);

            if (forwardPage == null) {
                forwardTo = "../../carbon/admin/index.jsp?loginStatus=true";
            } else {
                forwardTo = forwardPage;
            }
        } else {
            session.setAttribute("openId", openID);
            session.setAttribute("openIdURL", openID.getOpenID());
            forwardTo = "associate_openid.jsp";

            if (forwardPage != null) {
                forwardTo = forwardTo + "?forwardPage=" + URLEncoder.encode(forwardPage, "UTF-8") +
                        "&css=" + URLEncoder.encode(cssLocation, "UTF-8") + "&title=" +
                        URLEncoder.encode(pageTitle, "UTF-8");
            }
        }
    } catch (Exception e) {
        String message = resourceBundle.getString("openid.not.accepted");
        CarbonUIMessage.sendCarbonUIMessage(message, CarbonUIMessage.ERROR, request);
        forwardTo = "index.jsp?region=region1&item=infocard_sign_in";

        if (forwardPage != null) {
            forwardTo = "index.jsp?forwardPage=" + URLEncoder.encode(forwardPage, "UTF-8") +
                    "&css=" + URLEncoder.encode(cssLocation, "UTF-8") + "&title=" +
                    URLEncoder.encode(pageTitle, "UTF-8");                
        }
    }
%>


<%@page import="java.util.ResourceBundle" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="java.net.URLEncoder" %>
<script type="text/javascript">
    function forward() {
        location.href = "<%=forwardTo%>";
    }
</script>

<script type="text/javascript">
    forward();
</script>
